import { StringTypeMapping } from "TypeBuilder";
import { ConvenienceRenderer } from "../ConvenienceRenderer";
import { Name, Namer } from "../Naming";
import { RenderContext } from "../Renderer";
import { BooleanOption, Option, OptionValues } from "../RendererOptions";
import { Sourcelike } from "../Source";
import { TargetLanguage } from "../TargetLanguage";
import { ClassProperty, EnumType, ObjectType, Type } from "../Type";
export declare const typeScriptZodOptions: {
    justSchema: BooleanOption;
};
export declare class TypeScriptZodTargetLanguage extends TargetLanguage {
    protected getOptions(): Option<any>[];
    constructor(displayName?: string, names?: string[], extension?: string);
    get stringTypeMapping(): StringTypeMapping;
    get supportsOptionalClassProperties(): boolean;
    protected makeRenderer(renderContext: RenderContext, untypedOptionValues: {
        [name: string]: any;
    }): TypeScriptZodRenderer;
}
export declare class TypeScriptZodRenderer extends ConvenienceRenderer {
    protected readonly _options: OptionValues<typeof typeScriptZodOptions>;
    constructor(targetLanguage: TargetLanguage, renderContext: RenderContext, _options: OptionValues<typeof typeScriptZodOptions>);
    protected forbiddenNamesForGlobalNamespace(): string[];
    protected nameStyle(original: string, upper: boolean): string;
    protected makeNamedTypeNamer(): Namer;
    protected makeUnionMemberNamer(): Namer;
    protected namerForObjectProperty(): Namer;
    protected makeEnumCaseNamer(): Namer;
    protected importStatement(lhs: Sourcelike, moduleName: Sourcelike): Sourcelike;
    protected emitImports(): void;
    protected typeMapTypeForProperty(p: ClassProperty): Sourcelike;
    protected typeMapTypeFor(t: Type, required?: boolean): Sourcelike;
    protected emitObject(name: Name, t: ObjectType): void;
    protected emitEnum(e: EnumType, enumName: Name): void;
    protected emitSchemas(): void;
    protected emitSourceStructure(): void;
}
